// importing the csv and scatter plot from respective libraries
import { csv, select } from 'd3';
import { scatterPlot } from './scatterPlot';
// importing the csv data from github
const csvUrl = [
  'https://gist.githubusercontent.com/','curran/','a08a1080b88344b0c8a7/','raw/0e7a9b0a5d22642a06d3d5b9bcbad9890c8ee534/','iris.csv',].join('');
// storing the data into each variable
const parseRow = (d) => {
  d.sepal_length = +d.sepal_length;
  d.sepal_width = +d.sepal_width;
  d.petal_length = +d.petal_length;
  d.petal_width = +d.petal_width;
  return d;
};
// defining the width and height
const width = window.innerWidth;
const height = window.innerHeight;
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);
// generating the plot based on values from above
const main = async () => {
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
    .xValue((d) => d.petal_width)
    .yValue((d) => d.sepal_length)
    .margin({
      top: 20,
      right: 20,
      bottom: 40,
      left: 50,
    })
    .radius(5);
  svg.call(plot);
//x-axis 
  svg.append("text")
    			 .attr("class", "x label")
    			 .attr("text-anchor", "end")
    			 .attr("x", 960)
    		   .attr("y", 500)
           .attr("stroke", "Black")
    			 .text("Sepal length");
// y-axis
        svg.append("text")
    		 .attr("class", "y label")
    		 .attr("text-anchor","end")
         .attr("y",height - 2)
    		 .attr("y", -30)
    		 .attr("dy", "3em")
    		 .attr("transform", "rotate(-90)")
         .attr("stroke", "Black")
    		 .text("Petal length");
const columns = [
    'petal_width',
    'sepal_width',
    'petal_length',
    'sepal_length',
  ];
  
// We are rendering the graph using this plot-- reusing the scatter plot
  let i = 0;
  setInterval(() => {
    plot.xValue((d) => d[columns[i % columns.length]]);
    svg.call(plot);
    i++;
  }, 2000);
};
main();



